Subject: Re: sk_buff handling in packet handler

From: Evgeniy Polyakov <[email-masked]>
Date: Sun, 17 May 2009 00:19:49 +0400

On Sat, May 16, 2009 at 12:31:28PM -0400, Claude Robitaille ([email-masked]) wrote:
> I suspect that the handler needs to do something with the sk_buff but I 
> am not sure what. I printed the content of the sk_buff and found that 
> the skb_buff is not cloned (looking on the web I had found that the 
> sk_buff should have been cloned) and that he number of users is 1.
> 
> Should I simply do a dev_kfree_skb? What are the rules governing the use 
> of the sk_buff in a packet handler? Should I clone the sk_buff?
> 
> Also, a related question, the packet handler is expected to return an 
> int. What should be returned?

Use packet socket code as the best documentation, in particular
packet_rcv, but 0 is ok, although in theory it should match NET_RX_*
constants.

-- 
	Evgeniy Polyakov